//=============================================================================
#include <windows.h>
#include <conio.h>
#include <stdio.h>
#include "counter_c.c"
//=============================================================================

//--------------------
// Build with /O2 /G6
//--------------------

static int sumlol(int m)
{
    int i, sum = 0, left = m % 15;
    for (i = 0; i < m - left; i += 15)
    {
        sum += 7 * i + 3 + 5 + 6 + 9 + 10 + 12;
    }
    for (i = m - left; i < m; i++)
    {
        if(i % 3 == 0 || i % 5 == 0)
        {
            sum += i;
        }
    }
    return sum;
}

static unsigned long sumlol2(unsigned long m)
{
    // C chokes on the m -= left;
    unsigned long left = m % 15; m -= left;
    unsigned long sum = (m - 1) / 15 * ((m - 1) / 15 + 1) / 2 * 15 * 7 + 45 * (m / 15);
    for (; left != 0; m++, left--)
    {
        if(m % 3 == 0 || m % 5 == 0)
        {
            sum += m;
        }

    }
    return sum;
}

//----------------------------------------------------
// This necessary to prevent /O1 or /O2 optimizations
// from breaking something in the macro code.
//----------------------------------------------------

#pragma optimize( "", off )

int main(void)
{
    int i;

    for (i=0;i<100;i++)
            printf( "%d:\t%d\t%d\n", i, sumlol(i), sumlol2(i) );

    Sleep(4000);

    CTR_BEGIN( 1, 1000, HIGH_PRIORITY_CLASS )
        sumlol(0);
    CTR_END( 1 )
    printf( "\n0\t%d cycles\n", ctr_cycles );

    CTR_BEGIN( 2, 1000, HIGH_PRIORITY_CLASS );
        sumlol(99);
    CTR_END( 2 )
    printf( "99\t%d cycles\n", ctr_cycles );

    CTR_BEGIN( 3, 1000, HIGH_PRIORITY_CLASS )
        sumlol2(0);
    CTR_END( 3 )
    printf( "\n0\t%d cycles\n", ctr_cycles );

    CTR_BEGIN( 4, 1000, HIGH_PRIORITY_CLASS );
        sumlol2(99);
    CTR_END( 4 )
    printf( "99\t%d cycles\n", ctr_cycles );

    getch();
    return 0;
}

#pragma optimize( "", on )
